
function tabloc_setting_startup(){
	tabloc_setting_makeKeyList("listLockKey");
	tabloc_setting_makeKeyList("listProtectKey");
	tabloc_setting_makeKeyList("listLockProtectKey");
	tabloc_setting_load();
}

function tabloc_setting_accept(){
	tabloc_setting_save();
	return true;
}

/**
 * pref ǂݍŃRg[̒lݒ肷
 */
function tabloc_setting_load(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");
		var prefType = prefElement.getAttribute("preftype");

		var prefValue = tabloc_setting_getPrefValue(prefString, prefType);

		prefElement[prefAttribute] = prefValue;
		prefElement.setAttribute(prefAttribute, prefValue);
	}
}

/**
 * Rg[̒l pref ɕۑ
 */
function tabloc_setting_save(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");
		var prefType = prefElement.getAttribute("preftype");

		var prefValue = prefElement[prefAttribute];
		var prefLastValue = tabloc_setting_getPrefValue(prefString, prefType);

		if(prefType == "number"){
			prefValue = parseInt(prefValue);
			if(isNaN(prefValue)) { prefValue = prefLastValue; }
		}

		if(prefValue != prefLastValue) {
			tabloc_setting_setPrefValue(prefString, prefValue, prefType);
		}
	}
}

function tabloc_setting_getPrefValue(aPrefString, aPrefType){
	try{
		switch(aPrefType){
			case "boolean":
				return tabloc_pref.getBoolPref(aPrefString);
			case "number":
				return tabloc_pref.getIntPref(aPrefString);
			case "string":
				return tabloc_pref.getCharPref(aPrefString);
		}
	}catch(e){}
	return 0;
}

function tabloc_setting_setPrefValue(aPrefString, aPrefValue, aPrefType) {
	switch(aPrefType){
		case "boolean":
			tabloc_pref.setBoolPref(aPrefString, aPrefValue);
			break;
		case "number":
			tabloc_pref.setIntPref(aPrefString, aPrefValue);
			break;
		case "string":
			tabloc_pref.setCharPref(aPrefString, aPrefValue);
			break;
	}
}

function tabloc_charCode(str){
	return str.charCodeAt(0);
}

function tabloc_setting_makeKeyList(menu){
	var listKey = document.getElementById(menu);
	listKey.removeAllItems();
	listKey.appendItem("(none)", "");
	for(var i=tabloc_charCode("A"); i <= tabloc_charCode("Z"); i++){
		var str = String.fromCharCode(i);
		listKey.appendItem(str, str);
	}
}
